using System;
using System.Globalization;

namespace WebAndLoadTestPluginsAndRules.Common
{
    public class StartsWithFilter : Filter
    {
        public string Filter { get; set; }
        public bool IgnoreCase { get; set; }

        public StartsWithFilter(string filter, bool ignoreCase)
        {
            if (string.IsNullOrEmpty(filter))
            {
                throw new ArgumentException("filter must be specified", "filter");
            }
            Filter = filter;
            IgnoreCase = ignoreCase;
        }

        public override bool Matches(string value)
        {
            if (value == null)
            {
                return false;
            }
            return value.StartsWith(Filter, IgnoreCase, CultureInfo.InvariantCulture);
        }
    }
}