﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using WebAndLoadTestPluginsAndRules.Properties;

namespace WebAndLoadTestPluginsAndRules
{
    [Serializable]
    internal sealed class LocalizableDisplayNameAttribute : DisplayNameAttribute
    {
        public LocalizableDisplayNameAttribute(string resourceId) : base(Resources.ResourceManager.GetString(resourceId, Resources.Culture)) { }
    }

    [Serializable]
    internal sealed class LocalizableDescriptionAttribute : DescriptionAttribute
    {
        public LocalizableDescriptionAttribute(string resourceId) : base(Resources.ResourceManager.GetString(resourceId, Resources.Culture)) { }
    }

    [Serializable]
    internal sealed class LocalizableCategoryAttribute : CategoryAttribute
    {
        public LocalizableCategoryAttribute(string resourceId) : base(Resources.ResourceManager.GetString(resourceId, Resources.Culture)) { }
    }
}
