﻿//-----------------------------------------------------------------------------------
// Validation Rule Template version 1.0
//-----------------------------------------------------------------------------------
using System;
using System.Diagnostics;
using System.Globalization;
using Microsoft.VisualStudio.TestTools.WebTesting;

namespace $rootnamespace$
{

    [System.ComponentModel.DisplayName("$itemname$")]
    [System.ComponentModel.Description("TODO: Add a more detailed description of '$itemname$' validation rule.")]
    public class $safeitemname$ : ValidationRule
    {

        #region Constructor
        /// <summary>
        /// standard constructor
        /// </summary>
        public $safeitemname$() { }
        #endregion

        #region Properties
        /*
         * Public properties on the class will be surfaced to the user in the VS UI.
         * Only string, int, and bool types are allowed.
         */

        /*
                /// <summary>
                /// Sample string property
                /// </summary>
                private string m_myStringProperty;
                [System.ComponentModel.DisplayName("My String Property")]
                [System.ComponentModel.Description("Enter a long description for this property.")]
                [System.ComponentModel.DefaultValue("MyString")]
                public string MyStringProperty
                {
                    get { return m_myStringProperty; }
                    set { m_myStringProperty = value; }
                }
        */

        /// <summary>
        /// Contains a message that is surfaced to the user
        /// </summary>
        string m_message;
        public string Message
        {
            get { return m_message; }
        }

        #endregion //Properties

        #region Validate Method

        /// <summary>
        /// A sample utility function that performs the actual work of validating values. 
        /// This demonstrates the best practice of moving most of the code out into 
        /// it's own function so you can test it from a unit test.
        /// </summary>
        /// <param name="sInputString">String to search</param>
        /// <param name="sReason">reason search failed</param>
        /// <returns>true - value found, false - value not found, reason contains more details</returns>
        private static bool Validate(string document)
        {
            Debug.Assert(document != null);

            // TODO:  Implement your Validation code here
            throw (new NotImplementedException("ValidationRule1:MyValidationFunction not implemented !"));

            // m_message = "Additional information regarding success/failure of function";
            // return true; // true if found, false if not found
        }

        /// <summary>
        /// The Validate method is called by the web test engine when the request is complete.
        /// e contains the request and response you need to validate.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 
        public override void Validate(object sender, ValidationEventArgs e)
        {
            try
            {
                e.IsValid = Validate(e.Response.BodyString);
                e.Message = Message;
            }
            catch (Exception ex)
            {
                e.Message = String.Format(CultureInfo.CurrentCulture, "{ValidationRule1} Exception: {0}", ex.Message.ToString());
                e.IsValid = false;
            }
        }
        #endregion


        #region TestCode
        /*
        /// <summary>
        /// This section contains unit test that you can call to validate 
        /// that your function works correctly
        /// You should move this code to a test class.
        /// </summary>
        [TestMethod]
        public void Test_ValidationRule1_ValidationRule()
        {
            //
            //TODO:  Add valid test to confirm correct functionallity
            //
            // You should test for positive and non positive cases 
            
            // Positive test coniditions (value found)
            this.MyStringProperty = "test input";
            Assert.IsTrue(Validate("<html><body>sample html document</body></html>"));
            //
            // Non Positive Test conditions (value not found)
            this.MyStringProperty = "negative test input";
            Assert.IsFalse(Validate("<html><body>sample html document</body></html>"));
            Assert.IsTrue(Message.Compare("Expected message"), 0);
        }
        */
        #endregion
    }

}
